/*
-------------------------------------------------------------------
DSudoku 1.0: a WinS Sudoku game using Sudoku Sensei 1.03
Copyright (C) 2005 Patrick Huy

SUDOKU SENSEI 1.03
Copyright (C) 2005  Martin Knoblauch

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
MA  02110-1301, USA.

-------------------------------------------------------------------
*/
#include <winsapi.h>
#include "sudoku-pub.h"

class Pos {
public:
	int x,y;
	Pos (int _x, int _y) : x(_x), y(_y) { }
	Pos () { }
};

struct SudokuWu {
	int realValue;
	int visibleValue;
	bool userSet;
};

class CtlSudoku : public Control {
public:
	CtlSudoku (Bbox b);
	void FocusField (int _x, int _y);
	bool setFocusedTo (int newVal);
	int getFocusedValue () { return field[focus.x][focus.y].visibleValue; }
	bool getFocusedChangeable () { return field[focus.x][focus.y].userSet; }
	void setHelp (bool _help) { this->help = _help; this->_DrawForeground(); }
	void Create ();
	int WS_MSG_SUDOKU_FOCUS_CHANGED;
	int WS_MSG_SUDOKU_CLEARED;
protected:
	void HandleMessages();
	void _DrawBackground();
	void _DrawForeground();
	void _DrawBorders();
	Bbox fieldBbox (int x, int y);

	Pos focus;
	bool help;
	bool done;
	SudokuWu field[9][9];
};
