/*
-------------------------------------------------------------------
SUDOKU SENSEI 1.03: a Sudoku Explainer Engine
Copyright (C) 2005  Martin Knoblauch

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
MA  02110-1301, USA.

Contact the author: comocomocomo AT users.sourceforge.net
Latest versions: http://sourceforge.net/projects/sudoku-sensei
-------------------------------------------------------------------

    demo0-minimal-solver.c
*/

#include <stdio.h>
#include <stdlib.h>

#include "../../../sudoku-sensei/sudoku-pub.h"

#ifdef WINDOWS
#define SYSTEM_PAUSE system ("pause")
#else
#define SYSTEM_PAUSE
#endif

int main ()
{
  t_board_p b;

  char T[] = ". . 1   6 . 4   . 8 ."  /* A very difficult */
             ". . .   . . 3   2 . ."  /* one */
             ". . 3   5 . .   6 . ."
                                      /* (spaces are ignored) */
             ". . .   . . .   . 1 9"
             "9 7 .   . 8 2   . . ."
             ". . .   . . .   8 . ."

             ". . .   . . .   9 2 ."
             "8 6 .   . . .   . 5 ."
             ". 9 .   . 3 .   4 . 8";

  PrintGPL (stdout);    /* Show License */

  b = ConstructBasicBoard (3,       /* (3*3)*(3*3) == 81 cells */
                           FALSE);  /* No diagonals */

  if (b)
  {
    SetBoard (b,       /* Board to set */
              T,       /* Source */
              NULL,    /* Default symbols (1..9) */
              NULL);   /* Default "empty" symbols */

    printf ("Problem:\n");
    PrintBoard (b, stdout, NULL, NULL);  /* Default symbols... */

    Solve (b,        /* Board to solve */
           0,        /* Don't stop */
           FALSE);   /* Don't guess */

    printf ("\nSolution:\n");
    PrintBoard (b, stdout, NULL, NULL);

    DestroyBoard (b);
  }

  SYSTEM_PAUSE;
  return 0;
}
