/*
-------------------------------------------------------------------
SUDOKU SENSEI 1.03: a Sudoku Explainer Engine
Copyright (C) 2005  Martin Knoblauch

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
MA  02110-1301, USA.

Contact the author: comocomocomo AT users.sourceforge.net
Latest versions: http://sourceforge.net/projects/sudoku-sensei
-------------------------------------------------------------------

    demo1-samurai-solver.c
*/

#include <stdio.h>
#include <stdlib.h>

#include "../../../sudoku-sensei/sudoku-pub.h"

#ifdef WINDOWS
#define SYSTEM_PAUSE system ("pause")
#else
#define SYSTEM_PAUSE
#endif

int main ()
{
  t_board_p b;

  char T[] =     /* A very difficult samurai */

  " . . .   . . 6   . 2 .           6 . 7   . . .   . . . "
  " . . .   1 3 .   . . 7           . 5 .   . . .   1 . . "
  " . . .   2 . .   . . .           . 2 1   8 . .   . . . "

  " . . .   4 9 .   5 . 1           . . .   . 1 6   . 9 . "
  " . . 1   . 2 .   . 9 .           2 . .   . . 3   8 . 1 "
  " . 6 .   . 5 .   . . .           . . .   7 2 .   . 3 . "

  " . 5 4   . . .   . . .   7 . 3   . . .   . . .   . 6 . "
  " 9 . .   . . .   . . .   . . .   . . .   . . .   . . . "
  " 6 . .   7 . .   . . .   . 5 2   . . .   . . .   4 . 5 "

  "                 . 3 2   . . 6   . . .                 "
  "                 4 6 5   . . .   8 . .                 "
  "                 . . .   . . .   1 . .                 "

  " 7 . 3   . . .   . . .   . . .   . . .   . . 5   9 . . "
  " . . .   . . .   . . .   . . .   . . .   7 . .   . . . "
  " . . .   7 6 4   . . .   . . 1   . . .   . . .   1 3 . "

  " . . 6   9 . .   4 . .           . . .   . . .   . 1 . "
  " 5 . .   . 2 .   1 . .           . . .   4 . 2   . . 6 "
  " . . .   8 . 5   . . 3           . 9 5   . . 3   . 2 . "

  " . . .   6 . .   . . .           . . .   . 2 7   . . . "
  " 8 5 .   . . .   2 . .           . . 6   . . 4   8 5 . "
  " 4 . .   2 . 3   . . .           . . 8   . . .   . . 9 ";

  PrintGPL (stdout);   /* Show License */

  b = ConstructSamuraiBoard (3, 3, FALSE);  /* (3*3)*(3*3) */
                                            /* Samurai */
  if (b)
  {
    SetBoard (b, T, NULL, NULL);

    printf ("Problem:\n");
    PrintBoard (b, stdout, NULL, NULL);

    Solve (b, 0, FALSE);

    printf ("\nSolution:\n");
    PrintBoard (b, stdout, NULL, NULL);

    DestroyBoard (b);
  }

  SYSTEM_PAUSE;
  return 0;
}
