#include "my_ctldroplist.h"

#define max(x,y) (x>y?x:y)

void my_CtlDropList::drawButton(bool isPressed, Bbox butBox, char label)
{
	u16 c=_OpenButton->GetBackColor();
	if(c==WS_COLOR_WHITE)
		c=WS_COLOR_LIGHTGREY;
	#define LIGHTNER 7 
	int r,g,b; r=c&0x1F; g=(c&0x03E0)>>5; b=(c&0x7C00)>>10;
	u16 backColor=RGB2INT(r,g,b);
	u16 colorLight=RGB2INT(((r+LIGHTNER)>31)?31:(r+LIGHTNER),((g+LIGHTNER)>31)?31:(g+LIGHTNER),((b+LIGHTNER)>31)?31:(b+LIGHTNER));
	u16 colorDark=RGB2INT(((r-LIGHTNER)<0)?0:(r-LIGHTNER),((g-LIGHTNER)<0)?0:(g-LIGHTNER),((b-LIGHTNER)<0)?0:(b-LIGHTNER));
	u16 colorDarkest=RGB2INT(((r-LIGHTNER*2)<0)?0:(r-LIGHTNER*2),((g-LIGHTNER*2)<0)?0:(g-LIGHTNER*2),((b-LIGHTNER*2)<0)?0:(b-LIGHTNER*2));
		
	if(isPressed) {
		Screen.DrawHLine(butBox.x, butBox.x+butBox.xdim-1,  butBox.y, colorDarkest);
		Screen.DrawVLine(butBox.x, butBox.y, butBox.y+butBox.ydim-1, colorDarkest);
		Screen.DrawHLine(butBox.x, butBox.x+butBox.xdim-1, butBox.y+butBox.ydim-1, colorLight);
		Screen.DrawVLine(butBox.x+butBox.xdim-1, butBox.y, butBox.y+butBox.ydim-1, colorLight);
		Screen.DrawHLine(butBox.x+1, butBox.x+butBox.xdim-2,  butBox.y+1, colorDark);
		Screen.DrawVLine(butBox.x+1, butBox.y+1, butBox.y+butBox.ydim-2, colorDark);
		Screen.DrawHLine(butBox.x+1, butBox.x+butBox.xdim-2, butBox.y+butBox.ydim-2, backColor);
		Screen.DrawVLine(butBox.x+butBox.xdim-2, butBox.y+1, butBox.y+butBox.ydim-2, backColor);
	} else {
		Screen.DrawHLine(butBox.x, butBox.x+butBox.xdim-1,  butBox.y, colorLight);
		Screen.DrawVLine(butBox.x, butBox.y, butBox.y+butBox.ydim-1, colorLight);
		Screen.DrawHLine(butBox.x, butBox.x+butBox.xdim-1, butBox.y+butBox.ydim-1, colorDarkest);
		Screen.DrawVLine(butBox.x+butBox.xdim-1, butBox.y, butBox.y+butBox.ydim-1, colorDarkest);
		Screen.DrawHLine(butBox.x+1, butBox.x+butBox.xdim-2,  butBox.y+1, backColor);
		Screen.DrawVLine(butBox.x+1, butBox.y+1, butBox.y+butBox.ydim-2, backColor);
		Screen.DrawHLine(butBox.x+1, butBox.x+butBox.xdim-2, butBox.y+butBox.ydim-2, colorDark);
		Screen.DrawVLine(butBox.x+butBox.xdim-2, butBox.y+1, butBox.y+butBox.ydim-2, colorDark);
	}
	Screen.Fill(butBox.Inside(2), _OpenButton->GetBackColor());
	Screen.Printf(_font, butBox.x+(butBox.xdim-_font.GetWidth(label))/2, butBox.y+(butBox.ydim-_font.GetHeight())/2, _OpenButton->GetForeColor(), "%c", label);
}

my_CtlDropList::my_CtlDropList(const Bbox &b)
   :Control(b),_font((Font&)SystemFont)
{
_ctlstyle=HEAVY_INNER;
SetCanBeResizedY(false);
_backcolor=WS_COLOR_WHITE;
originalbkcolor = WS_COLOR_WHITE;
_flag = true;
SetDimY(SystemFont.GetHeight()+6);

_currentitem = -1;
curItemPrint = 0;
limitScroller = 4;

_OpenButton = new CtlButtonEx(Bbox(GetDimX()-17, 0, 17, GetDimY()).Inside(2), "v", SystemFont);
_OpenButton->AnchorX();
AddSubControl( _OpenButton );
isGreather = false;
}

my_CtlDropList::my_CtlDropList(const Bbox &b, Font& f)
   :Control(b),_font(f)
{
_ctlstyle=HEAVY_INNER;
SetCanBeResizedY(false);
_backcolor=WS_COLOR_WHITE;
originalbkcolor = WS_COLOR_WHITE;
_flag = true;
SetDimY(f.GetHeight()+6);

_currentitem = -1;
curItemPrint = 0;
limitScroller = 4;

_OpenButton = new CtlButtonEx(Bbox(GetDimX()-17, 0, 17, GetDimY()).Inside(2), "v", f);
_OpenButton->AnchorX();
AddSubControl( _OpenButton );
isGreather = false;
}

int my_CtlDropList::GetItemAt(int x, int y)
{
Bbox vSize = Bbox(_bbox.x, _bbox.y+_bbox.ydim, _bbox.xdim, _labels.size()*(_font.GetHeight())+9);
if(!vSize.IsContained(x,y))
    return -1;
    
for(unsigned i=curItemPrint; i<_labels.size(); ++i)
    if(vSize.Inside(2).y+2+(_font.GetHeight()+1)*(i-curItemPrint) <= (unsigned) y &&
        vSize.Inside(2).y+2+(_font.GetHeight()+1)*((i+1)-curItemPrint) >=(unsigned) y)
        return i;
        
return -1;
}

void my_CtlDropList::AddItem(const char *s)
{
	_labels.push_back(s);
	if(signed(_labels.size())>limitScroller)
		isGreather = true;
}

void my_CtlDropList::_DrawForeground()
{
	if(_specialthemefr && _OpenButton->GetForeColor() != _forecolor)
		_OpenButton->SetForeColor(_forecolor);

	if( _currentitem == -1)
		return;
		
	Screen.Printf(_font, _bbox.x+4, _bbox.y+4, _forecolor, "%s", _labels[_currentitem].c_str());
}

void my_CtlDropList::_DrawBackground()
{	
	if(_specialthemebk && _OpenButton->GetBackColor() != _backcolor)
		_OpenButton->SetBackColor(_backcolor);
			
	Screen.Fill(_bbox.Inside(1), GetBackColor());
}

void my_CtlDropList::_Render(Bbox vSize)
{
	if(!isGreather)
		curItemPrint = 0;
		
	Bbox oldClipper = Screen.GetClipper();
	Screen.SetClipper(vSize.Inside(2));
	if(!reverse) {
		for(int i=curItemPrint; i < (int)_labels.size(); i++) {
			if(i==_currentitem) {
				Screen.Fill(Bbox(vSize.Inside(2).x,
					vSize.Inside(2).y+(i-curItemPrint)*(_font.GetHeight()+1)-1 + 1,
					vSize.Inside(2).xdim, _font.GetHeight()+2), _specialthemebk?_bordercolordark:(gWinS.GetIsUsingTheme()?gWinS.GetThemeColor():WS_COLOR_BLUE));
					
				Screen.Printf(_font, vSize.Inside(2).x+2,
					vSize.Inside(2).y+(i-curItemPrint)*(_font.GetHeight()+1) + 2, _backcolor,
					"%s",_labels[i].c_str());
			} else
				Screen.Printf(_font, vSize.Inside(2).x+2,
					vSize.Inside(2).y+(i-curItemPrint)*(_font.GetHeight()+1) + 2, _forecolor,
					"%s",_labels[i].c_str());
					
			if( isGreather && (i-curItemPrint)>limitScroller-2 )
				break;
		}
	} else {
		for(int i=_labels.size()-1; i >= 0; i--) {
			if(i == _currentitem) {
				Screen.Fill(Bbox(vSize.Inside(2).x,
					vSize.Inside(2).y+vSize.Inside(2).ydim-_bbox.Inside(2).ydim-(i-curItemPrint)*(_font.GetHeight()+1),
					vSize.Inside(2).xdim, _font.GetHeight()+2), _specialthemebk?_bordercolordark:(gWinS.GetIsUsingTheme()?gWinS.GetThemeColor():WS_COLOR_BLUE));
					
				Screen.Printf(_font, vSize.Inside(2).x+2,
					vSize.Inside(2).y+vSize.Inside(2).ydim-_bbox.Inside(2).ydim-(i-curItemPrint)*(_font.GetHeight()+1) + 2, _backcolor,
					"%s",_labels[i].c_str());
			} else	
				Screen.Printf(_font, vSize.Inside(2).x+2,
					vSize.Inside(2).y+vSize.Inside(2).ydim-_bbox.Inside(2).ydim-(i-curItemPrint)*(_font.GetHeight()+1) + 2, _forecolor,
					"%s",_labels[i].c_str());
		}
	}
	Screen.SetClipper(oldClipper);
}

void my_CtlDropList::HandleMessages()
{
	WS_MSG msg;
	s32 x,y;
	bool updateInd = true;
	
	Bbox scrollerBboxUp, scrollerBboxDown, backGrey, indButton;
	_OpenButton->SetAncestor( this ); 
	
	FORALLMESSAGES(msg) {
		switch(msg.id) {
			case WS_MSG_BUTTONPRESSED:
			case WS_MSG_POINTERINPUT:
				while( gWinS.InputReceived() );
					
				_OpenButton->SetStyle(INNER);
				_OpenButton->UpdateAll();
				gWinS.Draw();
				Screen.Show();
					
				Bbox vSize = Bbox(_bbox.x, _bbox.y+_bbox.ydim, _bbox.xdim, (_labels.size())*(_font.GetHeight()+2)+1+(4-_labels.size())); //why 4-size?
				if(signed(_labels.size()) > limitScroller)
					vSize.ydim = limitScroller*(_font.GetHeight()+2)+1+(4-limitScroller);
				Bbox temp = vSize;
				temp.Clip(Bbox(0,0,256,192));
				if( temp.ydim != vSize.ydim ) {
					vSize.y -= vSize.ydim+_bbox.ydim; //= Bbox(_bbox.x, _bbox.y-vSize.ydim, _bbox.xdim, (_labels.size())*(_font.GetHeight()+2)+1+(4-_labels.size())); //why 4-size?
					reverse = true;
				} else
					reverse = false;
					
					rechoose:
				Screen.DrawRectangle(vSize, (_specialthemebk|gWinS.GetIsUsingTheme())?_bordercolordarkest:0x8000);
				Screen.Fill(vSize.Inside(1), _backcolor);
					
				_Render(vSize);
				if(isGreather) {
					scrollerBboxUp = _OpenButton->GetBbox();
					scrollerBboxUp.y = vSize.y+2;
					scrollerBboxDown = _OpenButton->GetBbox();
					scrollerBboxDown.y = vSize.ydim+vSize.y-scrollerBboxUp.ydim-2;
					backGrey = Bbox(scrollerBboxUp.x, scrollerBboxUp.y+scrollerBboxUp.ydim, scrollerBboxUp.xdim, vSize.Inside(1).ydim-scrollerBboxUp.ydim*2-2);
					Screen.Fill(backGrey, (_specialthemebk|gWinS.GetIsUsingTheme())?_bordercolordark:RGB2INT(27,27,27));
					drawButton(false, scrollerBboxUp, '^');
					drawButton(false, scrollerBboxDown, 'v');
					if(updateInd) {
						indButton = scrollerBboxUp;
						indButton.ydim = limitScroller*backGrey.ydim/_labels.size();
						if(!reverse) {
							indButton.y += scrollerBboxUp.ydim + curItemPrint*backGrey.ydim/_labels.size();
							if(indButton.y+indButton.ydim > backGrey.y+backGrey.ydim)
								indButton.y = backGrey.y+backGrey.ydim - indButton.ydim;
							updateInd = false;
						} else {
							indButton.y = scrollerBboxDown.y-indButton.ydim - curItemPrint*backGrey.ydim/_labels.size();
							if(indButton.y+indButton.ydim < backGrey.y)
								indButton.y = backGrey.y - indButton.ydim;
							updateInd = false;
						}
					}
					drawButton(false, indButton, ' ');
				}
					
				Screen.Show();
					
				while( gWinS.InputReceived() );
				while( !gWinS.InputReceived() );
					
				while( gWinS.InputReceived() )
				{	
					Bbox rightSide = vSize.Inside(1);
					rightSide.xdim -= backGrey.xdim+1;
					gWinS.GetTouch(x,y);
					if(isGreather) {
						if(scrollerBboxUp.IsContained(x,y)) {
							drawButton(true, scrollerBboxUp, '^');
							Screen.Show();
							while( gWinS.InputReceived() );
							if(!reverse)
								--curItemPrint;
							else
								++curItemPrint;
								
							if(curItemPrint < 0 && !reverse)
								curItemPrint = 0;
							else if(curItemPrint > (int)_labels.size()-limitScroller && reverse)
								curItemPrint = _labels.size()-limitScroller;
								
							updateInd = true;
							goto rechoose;
						} else if(scrollerBboxDown.IsContained(x,y)) {
							drawButton(true, scrollerBboxDown, 'v');
							Screen.Show();
							while( gWinS.InputReceived() );
							if(!reverse)
								++curItemPrint;
							else
								--curItemPrint;
								
							if(curItemPrint > (int)_labels.size()-limitScroller && !reverse)
								curItemPrint = _labels.size()-limitScroller;
							else if(curItemPrint<0 && reverse)
								curItemPrint = 0;
								
							updateInd = true;
							goto rechoose;
						} else if(indButton.IsContained(x,y)) {
							drawButton(true, indButton, ' ');
							Screen.Show();
							int yAlign = y-indButton.y;
							while( gWinS.InputReceived() ) {
								gWinS.GetTouch(x, y);
								indButton.y = y-yAlign;
									
								if( indButton.y < backGrey.y )
									indButton.y = backGrey.y;
								if( indButton.y+indButton.ydim > backGrey.y+backGrey.ydim )
									indButton.y = backGrey.y+backGrey.ydim - indButton.ydim;
									
								int tempCalc = indButton.y - scrollerBboxUp.ydim - scrollerBboxUp.y;
								if(reverse)
									tempCalc = scrollerBboxDown.y - indButton.ydim - indButton.y;
								curItemPrint = (tempCalc*_labels.size())/backGrey.ydim;
								Screen.Fill(rightSide, 0xFFFF);
								_Render(vSize);
								Screen.Fill(backGrey, (_specialthemebk|gWinS.GetIsUsingTheme())?_bordercolordark:RGB2INT(27,27,27));
								drawButton(true, indButton, ' ');
								drawButton(false, scrollerBboxUp, '^');
								drawButton(false, scrollerBboxDown, 'v');
								Screen.Show();
							}
							goto rechoose;
						}
					}
					Screen.Fill(vSize.Inside(1), _backcolor);
					gWinS.GetTouch(x,y);
						
					Bbox oldClipper = Screen.GetClipper();
					Screen.SetClipper( vSize );
						
					if( rightSide.IsContained(x,y) ) {
						if(!reverse)
							_currentitem = GetItemAt(x,y);
						else {
							int ty = _bbox.y+(_bbox.ydim/2);
							int ty2 = y-ty; ty -= ty2;
							_currentitem = GetItemAt(x,ty);	
						}
					} else if(backGrey.IsContained(x,y))
						goto rechoose;
						
					_Render(vSize);
					Screen.Fill(backGrey, (_specialthemebk|gWinS.GetIsUsingTheme())?_bordercolordark:RGB2INT(27,27,27));
					drawButton(false, scrollerBboxUp, '^');
					drawButton(false, scrollerBboxDown, 'v');
					drawButton(false, indButton, ' ');
						
					Screen.SetClipper( oldClipper );
					UpdateAll();
					gWinS.Draw();
					Screen.Show();
				}
				gWinS.UpdateAll();
				gWinS.Draw();
				Screen.Show();
					
				if(_ancestor && _currentitem != -1)
					SendMessage(WS_MSG_DROPDOWNLISTCHOICE, _ancestor, _currentitem);
					
				_OpenButton->SetStyle(OUTER);
				break;
		}
	}
Control::HandleMessages();
}

void my_CtlDropList::SetFont(Font& f)
{
	_font = f;
	SetDimY(f.GetHeight()+6);
	RemoveSubControl(_OpenButton->GetID());
	_OpenButton->Destroy();
	_OpenButton = new CtlButtonEx(Bbox(GetDimX()-GetDimY()-4, 0, GetDimY()-4, GetDimY()).Inside(2), "v", f);
	AddSubControl(_OpenButton);
	UpdateAll();
}

void my_CtlDropList::RemoveItem(int n)
{
	if(n > GetItemCount()-1)
		return;
		
	if(n == GetSelectedItem())
		SetItem(-1);
		
	int j = 0;
	if((int)_labels.size() == GetSelectedItem())
		_labels.erase(--_labels.end());
	else
		for(vector<string>::iterator i=_labels.begin(); i!=_labels.end(); ++i) {
			if(j==n)
				_labels.erase(i);
				
			j++;
		}
	UpdateAll();
		
	if((int)_labels.size()<limitScroller) {
		isGreather = false;
		curItemPrint = 0;
	}
}

void my_CtlDropList::ClearAll()
{
	_labels.clear();
	_currentitem=-1;
	curItemPrint = 0;
	isGreather=false;
}
