/*+----------------------------------------------+
  | Cippotto: WinDS Chip8 Emulator               |
  | (c) Francesco Lombardi 2006                  |
  +----------------------------------------------+
    Created for WinDS 2006 Compo
    http://www.gbawins.com
    http://itaprogaming.free.fr
  +----------------------------------------------+*/

#include <winsapi.h>
#include "key.h"
#include "romsData.h"
#include "pong.h"
#include "tetris.h"
#include "brix.h"


class Chip8Screen_Class : public CtlGfxSurface
{
  public:
    int myMsg;
    Chip8Screen_Class(const Bbox &b, int xdim, int ydim);
    void HandleMessages();
  protected:
    void _DrawForeground();
};

class Chip8Console_Class : public CtlGfxSurface
{
  public:
    int myMsg;
    Chip8Console_Class(const Bbox &b, int xdim, int ydim);
    void HandleMessages();
    void DrawFrame();
  protected:
    void _DrawForeground();
};

/* Includes Chip8 emulator engine */
extern "C"
{
  #include "CHIP8.h"
}

/* Main emulator class */
class chip8wds_Class : public CtlWindow
{
  public:
    Chip8Screen_Class *EmuPaintBox; /* Chip8 Emulator surface                 */
    Chip8Console_Class *EmuConsole; /* Chip8 Console surface                  */
    key_map EmuKeys;                /* KeyPad settings                        */
    chip8wds_Class();               /* Constructor                            */
    ~chip8wds_Class();              /* Destructor                             */
    int uperiod;                    /* Number of interrupts per screen update */
    int sync;                       /* If 0, do not sync emulation            */    
    uint32 timer;                   /* Timer value at previous interrupt      */    
    void HandleMessages();          /* WinDS message handling                 */
    void update_display (void);     /* Draws the emulator screen              */
    void interrupt (void);          /* Emulator interrupt                     */
    void check_keys(void);          /* Checks keypad state                    */
    int load(void);                 /* Load a rom into Chip8 memory           */
    void resetAll(void);            /* Reset emulator and variables           */
  private:
  protected:
    CtlDropList *dlRomList;
};

extern chip8wds_Class *Chip8Emu;
