#include <winsapi.h>

#include "ctlbuttoncn.h"

CtlButtonCn::CtlButtonCn(const Bbox &b):
    Control(b)
{
    SetStyle(FLAT);
};

void CtlButtonCn::_DrawForeground()
{
#   define RNDR(mn,mx,my) \
    x = seData[mn].SizeEx(); \
    y = seData[mn].GetFont().GetHeight(); \
    Screen.Printf(seData[mn].GetFont(), \
    cx + (mx), cy + (my), \
    GetForeColor(), seData[mn].c_str());
    
    Bbox ca = GetClientArea();
    int cx, cy;
    int w, h;
    int x, y;
    
    ca.x    += xborder;
    ca.y    += yborder;
    ca.xdim -= xborder * 2;
    ca.ydim -= yborder * 2;
    
    cx = ca.x;
    cy = ca.y;
    
    w = ca.xdim;
    h = ca.ydim;
    
    // Top
    RNDR(0, 0,
            0);
    RNDR(1, (w - x) / 2,
            0);
    RNDR(2, (w - x),
            0);
    
    // Center
    RNDR(3, 0,
            (h - y) / 2);
    RNDR(4, (w - x) / 2,
            (h - y) / 2);
    RNDR(5, (w - x),
            (h - y) / 2);
    
    // Bottom
    RNDR(6, 0,
            (h - y));
    RNDR(7, (w - x) / 2,
            (h - y));
    RNDR(8, (w - x),
            (h - y));
    
#   undef RNDR
};

void CtlButtonCn::setText(enum corner cn, StringEx se)
{
    setText((int)cn, se);
};

void CtlButtonCn::setText(int cn, StringEx se)
{
    if(cn > 8
    || cn < 0)
    {
        return;
    };
    
    seData[cn] = se;
};

void CtlButtonCn::setTexts(StringEx se[])
{
    for(int i = 0; i < 9; i++)
    {
        setText(i, se[i]);
    };
};

void CtlButtonCn::setTexts(const char cd[])
{
    char n[2] = {0,0};
    
    for(int i = 0; i < 9; i++)
    {
        n[0] = cd[i];
        
        setText(i, StringEx(getText(i).GetFont(), n));
    };
};

StringEx CtlButtonCn::getText(enum corner cn)
{
    return(getText((int)cn));
};

StringEx CtlButtonCn::getText(int cn)
{
    if(cn > 8
    || cn < 0)
    {
        return(StringEx(""));
    };
    
    return(seData[cn]);
};

void CtlButtonCn::setFont(enum corner cn, Font &fn)
{
    setFont((int)cn, fn);
};

void CtlButtonCn::setFont(int cn, Font &fn)
{
    if(cn < 0
    || cn > 8)
    {
        return;
    };
    
    seData[cn].SetFont(fn);
};

void CtlButtonCn::setFonts(Font &fn)
{
    for(int i = 0; i < 9; i++)
    {
        setFont(i, fn);
    };
};

void CtlButtonCn::HandleMessages()
{
    WS_MSG msg;
    
    FORALLMESSAGES(msg)
    {
        SendMessage(msg.id, (Control *)GetParent(), msg.data);
    };
    
    Control::HandleMessages();
};

/* EOF */
