#include <winsapi.h>

#include "winsweeper.h"
#include "ctlminesquare.h"

CtlMineSquare::CtlMineSquare(Bbox b):
    Control(b)
{
    SetStyle(LIGHT_OUTER);
};

void CtlMineSquare::HandleMessages()
{
    WS_MSG msg;
    
    FORALLMESSAGES(msg)
    {
        switch(msg.id)
        {
            case WS_MSG_POINTERINPUT:
                if(gWinS.InputReceived())
                {
                    int x1, y1;
                    
                    gWinS.GetTouch(x1, y1);
                    
                    SendMessage(WS_MSG_BUTTONPRESSED, (Control *)GetParent(), 0);
                    
                    while(gWinS.InputReceived())
                    {
                        // DO NOTHING
                    };
                    
                    SendMessage(WS_MSG_BUTTONRELEASED, (Control *)GetParent(), 0);
                };
        };
    };
    
    Control::HandleMessages();
};

int CtlMineSquare::getType()
{
    return(type);
};

void CtlMineSquare::setType(int t)
{
    type = t;
    
    if(type & WINSWEEPER_FLAG_PRESS)
    {
        SetStyle(LIGHT_INNER);
    }
    else
    {
        SetStyle(LIGHT_OUTER);
    };
};

/* Messy... :P */
void CtlMineSquare::_DrawForeground()
{
    int image = -1;
    
    if(type & WINSWEEPER_FLAG_PRESS)
    {
        image = (type & WINSWEEPER_FLAG_ADJACENT) / WINSWEEPER_FLAG_ADJ(1);
        
        if(type & WINSWEEPER_FLAG_MINE)
        {
            image = 9;
        };
    }
    else
    {
        if(type & WINSWEEPER_FLAG_FLAG)
        {
            image = 10;
        };
    };
    
    if(image == -1)
    {
        return;
    };
    
    const u16 text_colors[] = {
        RGB15( 0, 0, 0),
        RGB15( 0, 0,23), RGB15( 0,23, 0),
        RGB15(23, 0, 0), RGB15( 0, 0,15),
        RGB15( 0,15, 0), RGB15( 0,15,15),
        RGB15( 0, 0, 0), RGB15(15,15,15),
        RGB15(15, 7, 0), RGB15(31, 7, 7)
    };
    
    const char text_codes[] = " 12345678#!";
    
    char buffer[2];
    
    buffer[0] = text_codes[image];
    buffer[1] = '\0';
    
    Screen.Printf((Font &)SmallFont,
                  GetClientArea().x + (GetClientArea().xdim - gWinS.GetSystemFont().GetWidth(buffer[0])) / 2,
                  GetClientArea().y + (GetClientArea().ydim - gWinS.GetSystemFont().GetHeight()) / 2,
                  text_colors[image], buffer);
};

/* EOF */

